Global Const $DIRECTINPUT_VERSION = 0x0800
Global Const $sCLSID_DirectInput = "{25E609E4-B259-11CF-BFC7-444553540000}"
Global Const $sIID_IDirectInput8W = "{BF798031-483A-4DA2-AA99-5D64ED369700}"
Global Const $sCLSID_DirectInputDevice = "{25E609E5-B259-11CF-BFC7-444553540000}"
Global Const $sIID_IDirectInputDevice8 = "{54D41081-DC15-4833-A41B-748F73A38179}"

Global Enum $DI_OK, $DI_NOEFFECT
Global Enum $S_OK, $S_FALSE
Global Enum $DIENUM_STOP, $DIENUM_CONTINUE

Global Enum $DI8DEVCLASS_ALL, $DI8DEVCLASS_DEVICE, $DI8DEVCLASS_POINTER, $DI8DEVCLASS_KEYBOARD, $DI8DEVCLASS_GAMECTRL

Global Const $DIEDFL_ALLDEVICES = 0x00000000
Global Const $DIEDFL_ATTACHEDONLY = 0x00000001
Global Const $DIEDFL_FORCEFEEDBACK = 0x00000100
Global Const $DIEDFL_INCLUDEALIASES = 0x00010000
Global Const $DIEDFL_INCLUDEPHANTOMS = 0x00020000
Global Const $DIEDFL_INCLUDEHIDDEN = 0x00040000

Global Const $DIDFT_ALL = 0x00000000
Global Const $DIDFT_ABSAXIS = 0x00000001
Global Const $DIDFT_RELAXIS = 0x00000002
Global Const $DIDFT_AXIS = 0x00000003
Global Const $DIDFT_PSHBUTTON = 0x00000004
Global Const $DIDFT_TGLBUTTON = 0x00000008
Global Const $DIDFT_BUTTON = 0x0000000C
Global Const $DIDFT_POV = 0x00000010
Global Const $DIDFT_COLLECTION = 0x00000040
Global Const $DIDFT_NODATA = 0x00000080
Global Const $DIDFT_ANYINSTANCE = 0x00FFFF00
Global Const $DIDFT_OPTIONAL = 0x80000000

Global Const $DIDOI_FFACTUATOR = 0x00000001
Global Const $DIDOI_FFEFFECTTRIGGER = 0x00000002
Global Const $DIDOI_POLLED = 0x00008000
Global Const $DIDOI_ASPECTPOSITION = 0x00000100
Global Const $DIDOI_ASPECTVELOCITY = 0x00000200
Global Const $DIDOI_ASPECTACCEL = 0x00000300
Global Const $DIDOI_ASPECTFORCE = 0x00000400
Global Const $DIDOI_ASPECTMASK = 0x00000F00


Global Const $DIPROP_RANGE = 4
Global Const $DIPROP_DEADZONE = 5
Global Const $DIPROP_PHYSICALRANGE = 18
Global Const $DIPROP_LOGICALRANGE = 19

Global Enum $DIPH_DEVICE, $DIPH_BYOFFSET, $DIPH_BYID, $DIPH_BYUSAGE
;DirectInputDevice: SetCooperativeLevel Constant
Global Enum Step *2 $DISCL_EXCLUSIVE, $DISCL_NONEXCLUSIVE, $DISCL_FOREGROUND, $DISCL_BACKGROUND, $DISCL_NOWINKEY

Global Const $tagIDirectInput8 = _
		"CreateDevice hresult(clsid;ptr*;ptr);" & _
		"EnumDevices hresult(dword;ptr;ptr;dword);" & _
		"GetDeviceStatus hresult(clsid);" & _
		"RunControlPanel hresult(hwnd;dword);" & _
		"Initialize hresult(handle;dword);" & _
		"FindDevice hresult(clsid;wstr;clsid*);" & _
		"EnumDevicesBySemantics hresult(wstr;ptr;ptr;ptr;dword);" & _
		"ConfigureDevices hresult(ptr;ptr;dword;ptr);"
Global Const $tagIDirectInputDevice8 = "GetCapabilities hresult(ptr);" & _
		"EnumObjects hresult(ptr;ptr;uint);" & _
		"GetProperty hresult(ptr;ptr);" & _
		"SetProperty hresult(ptr;ptr);" & _
		"Acquire hresult();" & _
		"Unacquire hresult();" & _
		"GetDeviceState hresult(uint;ptr);" & _
		"GetDeviceData hresult(uint;ptr;uint*;uint);" & _
		"SetDataFormat hresult(ptr);" & _
		"SetEventNotification hresult(ptr);" & _
		"SetCooperativeLevel hresult(ptr;uint);" & _
		"GetObjectInfo hresult(ptr;uint;uint);" & _
		"GetDeviceInfo hresult(ptr);" & _
		"RunControlPanel hresult(ptr;uint);" & _
		"Initialize hresult(handle;dword;clsid);" & _
		"CreateEffect hresult(ptr;ptr;ptr*;ptr);" & _
		"EnumEffects hresult(ptr;ptr;uint);" & _
		"GetEffectInfo hresult(ptr;ptr);" & _
		"GetForceFeedbackState hresult(uint*);" & _
		"SendForceFeedbackCommand hresult(uint);" & _
		"EnumCreatedEffectObjects hresult(ptr;ptr;uint);" & _
		"Escape hresult(ptr);" & _
		"Poll hresult();" & _
		"SendDeviceData hresult(uint;ptr;uint*;uint);" & _
		"EnumEffectsInFile hresult(wstr;ptr;ptr;uint);" & _
		"WriteEffectToFile hresult(wstr;uint;ptr;uint);" & _
		"BuildActionMap hresult(ptr;wstr;uint);" & _
		"SetActionMap hresult(ptr;wstr;uint);" & _
		"GetImageInfo hresult(ptr);"
; #STRUCTURE# ===================================================================================================================
; Name ..........: $tagDIDATAFORMAT
; Description ...:
; Fields ........: dwSize               - A dword value.
;                  dwObjSize            - A dword value.
;                  dwFlags              - A dword value.
;                  dwDataSize           - A dword value.
;                  dwNumObjs            - A dword value.
;                  rgodf                - A ptr value to struct DIOBJECTDATAFORMAT.
; Author ........: Thierry Kielbasiewicz
; Remarks .......: HRESULT SetDataFormat(LPCDIDATAFORMAT lpdf);
; Related .......:
; ===============================================================================================================================
Global Const $tagDIDATAFORMAT = "dword dwSize;dword dwObjSize;dword dwFlags;dword dwDataSize;dword dwNumObjs;ptr rgodf;"
; #STRUCTURE# ===================================================================================================================
; Name ..........: $tagDIOBJECTDATAFORMAT
; Description ...: See MSDN or Directinput SDK
; Fields ........: pguid                - A ptr value.
;                  dwOfs                - A dword value.
;                  dwType               - A dword value.
;                  dwFlags              - A dword value.
; Author ........: Thierry Kielbasiewicz
; Remarks .......: HRESULT SetDataFormat(LPCDIDATAFORMAT lpdf);
; Related .......:
; ===============================================================================================================================
Global Const $tagDIOBJECTDATAFORMAT = "ptr pguid;dword dwOfs;dword dwType;dword dwFlags;"
; #STRUCTURE# ===================================================================================================================
; Name ..........: $tagDIJOYSTATE
; Description ...:
; Fields ........: lX                   - A long value.   	1
;                  lY                   - A long value.		2
;                  lZ                   - A long value.		3
;                  lRX                  - A long value.		4
;                  lRY                  - A long value.		5
;                  lRZ                  - A long value.		6
;                  rglSlider[2]         - A long value.		7
;                  rgdwPOV[4]           - A long value.		8
;                  rgbButtons[32]       - A BYTE value.		9
; Author ........: Thierry Kielbasiewicz
; Remarks .......: HRESULT GetDeviceState(DWORD cbData, LPVOID lpvData);
; Related .......:
; ===============================================================================================================================
Global Const $tagDIJOYSTATE = "long lX;long lY;long lZ;long lRX;long lRY;long lRZ;long rglSlider[2];long rgdwPOV[4];BYTE rgbButtons[32];"
; #STRUCTURE# ===================================================================================================================
; Name ..........: $tagDIMOUSESTATE
; Description ...:
; Fields ........: lX                   - A long value.
;                  lY                   - A long value.
;                  lZ                   - A long value.
;                  rgbButtons[4]        - A BYTE value.
; Author ........: Thierry Kielbasiewicz
; Remarks .......: HRESULT GetDeviceState(DWORD cbData, LPVOID lpvData);
; Related .......:
; ===============================================================================================================================
Global Const $tagDIMOUSESTATE = "long lX;long lY;long lZ;BYTE rgbButtons[4];"
; #STRUCTURE# ===================================================================================================================
; Name ..........: $tagDIKEYBOARDSTATE
; Description ...:
; Fields ........: buffer[256]          - A wchar value.
; Author ........: Thierry Kielbasiewicz
; Remarks .......: HRESULT GetDeviceState(DWORD cbData, LPVOID lpvData);
; Related .......:
; ===============================================================================================================================
Global Const $tagDIKEYBOARDSTATE = "BYTE[256];"

;~ Global Const $c_dfDIKeyboard = _Init_c_dfDIKeyboard()
;~ Global Const $c_dfDIMouse = _Init_c_dfDIMouse()
;~ Global Const $c_dfDIJoystick = _Init_c_dfDIJoystick()
;Mouse ***************************
Global Const $LEFTBUTTON = 0
Global Const $RIGHTBUTTON = 1
Global Const $MIDDLEBUTTON = 2
Global Const $4BUTTON = 3
Global Const $5BUTTON = 4
Global Const $6BUTTON = 5
Global Const $7BUTTON = 6
Global Const $8BUTTON = 7
; ********************************
;Keyboard ***************************

Global Const $DIK_F1 = 0x3B
Global Const $DIK_F2 = 0x3C
Global Const $DIK_F3 = 0x3D
Global Const $DIK_F4 = 0x3E
Global Const $DIK_F5 = 0x3F
Global Const $DIK_F6 = 0x40
Global Const $DIK_F7 = 0x41
Global Const $DIK_F8 = 0x42
Global Const $DIK_F9 = 0x43
Global Const $DIK_F10 = 0x44
Global Const $DIK_F11 = 0x57
Global Const $DIK_F12 = 0x58

Global Const $DIK_0 = 0x0B
Global Const $DIK_1 = 0x02
Global Const $DIK_2 = 0x03
Global Const $DIK_3 = 0x04
Global Const $DIK_4 = 0x05
Global Const $DIK_5 = 0x06
Global Const $DIK_6 = 0x07
Global Const $DIK_7 = 0x08
Global Const $DIK_8 = 0x09
Global Const $DIK_9 = 0x0A

Global Const $DIK_NUMPAD0 = 0x52
Global Const $DIK_NUMPAD1 = 0x4F
Global Const $DIK_NUMPAD2 = 0x50
Global Const $DIK_NUMPAD3 = 0x51
Global Const $DIK_NUMPAD4 = 0x4B
Global Const $DIK_NUMPAD5 = 0x4C
Global Const $DIK_NUMPAD6 = 0x4D
Global Const $DIK_NUMPAD7 = 0x47
Global Const $DIK_NUMPAD8 = 0x48
Global Const $DIK_NUMPAD9 = 0x49
;on numeric keypad
Global Const $DIK_MULTIPLY = 0x37
Global Const $DIK_SUBTRACT = 0x4A
Global Const $DIK_ADD = 0x4E
Global Const $DIK_DECIMAL = 0x53
Global Const $DIK_NUMPADENTER = 0x9C
Global Const $DIK_DIVIDE = 0xB5

Global Const $DIK_E = 0x12
Global Const $DIK_R = 0x13
Global Const $DIK_T = 0x14
Global Const $DIK_Y = 0x15

Global Const $DIK_S = 0x1F
Global Const $DIK_D = 0x20
Global Const $DIK_F = 0x21
Global Const $DIK_G = 0x22
Global Const $DIK_H = 0x23
Global Const $DIK_J = 0x24
Global Const $DIK_K = 0x25
Global Const $DIK_L = 0x26
;Mode WERTY
;~ Global Const $DIK_A = 0x1E				;[a] en Qwerty [q] en Azerty
;~ Global Const $DIK_Q = 0x10
;~ Global Const $DIK_Z = 0x2C				;[z] en Qwerty [w] en Azerty
;~ Global Const $DIK_W = 0x11
;~ Global Const $DIK_M = 0x32				;[m] en Qwerty [,] en Azerty
;~ Global Const $DIK_SEMICOLON = 0x27		;[;] en Qwerty [m] en Azerty
;~ Global Const $DIK_COMMA = 0x33			;[,] en Qwerty [;] en Azerty
;~ Global Const $DIK_APOSTROPHE = 0x28		;['] en Qwerty [] en Azerty
;~ Global Const $DIK_GRAVE = 0x29			;[`] en Qwerty /* accent grave */ [] en Azerty
;~ Global Const $DIK_BACKSLASH = 0x2B		;[\] en Qwerty [Backslash] [*] en Azerty
;~ Global Const $DIK_PERIOD = 0x34			;[.] en Qwerty [:] en Azerty ($DIK_COLON)  crer
;~ Global Const $DIK_SLASH = 0x35			;[/] en Qwerty [!] en Azerty (poin d'exclamation)
;==========================================
;Mode AZERTY
Global Const $DIK_A = 0x10 ;[a] en Qwerty [q] en Azerty
Global Const $DIK_Q = 0x1E
Global Const $DIK_Z = 0x11 ;[z] en Qwerty [w] en Azerty
Global Const $DIK_W = 0x2C
Global Const $DIK_M = 0x27 ;[m] en Qwerty [,] en Azerty
Global Const $DIK_SEMICOLON = 0x33 ;[;] en Qwerty [m] en Azerty
Global Const $DIK_COMMA = 0x32 ;[,] en Qwerty [;] en Azerty
Global Const $DIK_UGRAVE = 0x28 ;[] en Azerty ['] en Qwerty
Global Const $DIK_EXPOSANT = 0x29 ;[`] en Qwerty /* accent grave */ [] en Azerty
Global Const $DIK_STAR = 0x2B ;[\] en Qwerty [Backslash] [*] en Azerty
Global Const $DIK_COLON = 0x34 ;[.] en Qwerty [:] en Azerty ($DIK_COLON)  crer
Global Const $DIK_EXCLAMATION = 0x35 ;[/] en Qwerty [!] en Azerty (poin d'exclamation)
;==========================================

Global Const $DIK_LWIN = 0xDB ;/* Left Windows key */
Global Const $DIK_RWIN = 0xDC ;/* Right Windows key */

Global Const $DIK_ESCAPE = 0x01
Global Const $DIK_TAB = 0x0F
Global Const $DIK_LSHIFT = 0x2A
Global Const $DIK_RSHIFT = 0x36
Global Const $DIK_LCONTROL = 0x1D
Global Const $DIK_RCONTROL = 0x9D
Global Const $DIK_BACKSPACE = 0x0E ;/ * backspace * /
Global Const $DIK_RETURN = 0x1C ;/ * Enter on main keyboard * /
Global Const $DIK_LALT = 0x38 ;/ * left Alt * /
Global Const $DIK_SPACE = 0x39
Global Const $DIK_CAPSLOCK = 0x3A
Global Const $DIK_NUMLOCK = 0x45
Global Const $DIK_SCROLL = 0x46 ;/ * Scroll Lock * /
Global Const $DIK_RALT = 0xB8 ;/ * right Alt * /
