;#include <GUIConstantsEx.au3>
;#include <WindowsConstants.au3>
#include <WinApi.au3>
#include <Array.au3>
#include <Timers.au3>

#include "DI_Constants.au3"
#include "_DirectInput.au3"
#include "VJOY_UDF.au3"

AutoItSetOption("GUICloseOnESC", 0)

;~ ; Error monitoring
Global $oError = ObjEvent("AutoIt.Error", "_ErrFunc")
Func _ErrFunc()
	ConsoleWrite("! COM Error !  Number: 0x" & Hex($oError.number, 8) & "   ScriptLine: " & $oError.scriptline & " - " & $oError.windescription & @CRLF)
	Return
EndFunc   ;==>_ErrFunc

Global $oIDirectInput8, $pIDirectInputDevice8

Local $hr, $i
$oIDirectInput8 = ObjCreateInterface($sCLSID_DirectInput, $sIID_IDirectInput8W, $tagIDirectInput8)
If @error Then _TraitError(@error, "Create Objet DirectInput")

$hr = $oIDirectInput8.Initialize(_WinAPI_GetModuleHandle(0), $DIRECTINPUT_VERSION)
If _Failed($hr) Then _TraitError($hr, "$oIDirectInput8.Initialize")

;Global $hmod = _WinAPI_GetModuleHandle("dinput8.dll") + 0x2d54
;RVA c_dijoystick2 	0x2d6c		rgof	0x21620
;RVA c_dijoystick 	0x2d54		rgof	0x21360
;RVA c_dikeyboard 	0x2d3c		rgof	0x20360
;RVA c_dimouse		0x2d24		rgof	0x202f0

;================ DirectInput Callback ===========================
Global $hCallback = DllCallbackRegister("_EnumAllProc", "bool", "ptr;ptr")
Global $hEnumObjectsCallback = DllCallbackRegister("_EnumObjectsProc", "bool", "ptr;ptr")
;=====================================================================================================
$WinHandle = GUICreate("My GUI") ; will create a dialog box that when displayed is centered
GUISetState(@SW_SHOW) ; will display an empty dialog box
Global $i1 = GUICtrlCreateLabel("Line 1 Cell 1", 10, 30, 70)
Global $i2 = GUICtrlCreateLabel("Line 1 Cell 1", 10, 70, 70)
Global $i3 = GUICtrlCreateLabel("Line 1 Cell 1", 10, 110, 70)
; #Constant# ====================================================================================================================
; $m1............: 0
; $k1............: 1
; $j1,jx.........: 2 to x -> j1 to jx joysticks
; $cNbDev........: Number of Devices jx
; Remarks........: See callback function EnumCallProc to force the Joy to jx
; ===============================================================================================================================
Global Enum $m1, $k1, $j1, $j2, $j3, $j4, $cNbDev ; <--- adapt following what you want

Global $oDev[$cNbDev], $stDI_STATE[$cNbDev], $stDI_LASTSTATE[$cNbDev]
InitKeyboard()
InitMouse()
InitJoystick()

DllCallbackFree($hCallback)
DllCallbackFree($hEnumObjectsCallback)

If @error Then _Quit()
For $i = 0 To $cNbDev - 1
	If Not IsObj($oDev[$i]) Then ContinueLoop
	_ZeroMemory(DllStructGetPtr($stDI_STATE[$i]), DllStructGetSize($stDI_STATE[$i]))
Next

Global $DEFJOY = 100
Global $DEFLAPSE = 300
Global Enum Step +9000 $UP, $RIGHT, $DOWN, $LEFT
Global Enum $STATE, $PRESSED, $RELEASED, $HELDDOWN, $DOUBLECLICKED
Global $hDLLVjoy = 0

Global $voice = ObjCreate("SAPI.SpVoice")
$voice.Speak("bonjour", 11)

_Vjoy_Startup()
;vjoystat()
_ZeroMemory(DllStructGetPtr($stVjoy), DllStructGetSize($stVjoy))
DllStructSetData($stVjoy, "bDevice", 1)

Global $Array_Var[1] = [0]

Global Const $pat_joybut = '(?i)^joystick(1[0-6]|[1-9])\.button([1-9]|[1-2]\d|3[0-2])$'; $idjoy,$but
Global Const $pat_joypov = '(?i)^joystick(1[0-6]|[1-9])\.pov([1-4])(up|left|down|right)?$'; $idjoy,$idpov,$pos or $idjoy,$idpov
Global Const $pat_mouse = '(?i)^mouse\.([[:alnum:]]*)$';$but
Global Const $pat_keyboard = '^(2[0-4]\d|25[0-5]|[01]?\d\d?)$';$key
Global Const $pat_var = '(?i)^var\.([[:alnum:]_]+)$';$var


_Timer_SetTimer($WinHandle, 30, "_GetDIData")

While 1

	Sleep(1000)
;~ 	Switch GUIGetMsg()
;~ 		Case $GUI_EVENT_CLOSE
;~ 			_Timer_KillAllTimers($WinHandle)
;~ 	EndSwitch
WEnd

Func _GetDIData($hWnd, $Msg, $iIDTimer, $dwTime)
	Static Local $frame = 0
	Static Local $BOUCLE = TimerInit()
	Static Local $FrameRate = 50
	Static Local $FrameTime = 1 / 50
	Static Local $Lasttick = 0

	If Not $frame Then				;definition global var -> used for test pressed, helddown and so on..
		Global $but3
	EndIf
	$frame += 1

	For $i = 0 To $cNbDev - 1
		If Not IsObj($oDev[$i]) Then ContinueLoop
		_ZeroMemory(DllStructGetPtr($stDI_STATE[$i]), DllStructGetSize($stDI_STATE[$i]))
		With $oDev[$i]
			$hr = .GetDeviceState(DllStructGetSize($stDI_STATE[$i]), DllStructGetPtr($stDI_STATE[$i]))
			If _Failed($hr) Then
				;DIERR_INPUTLOST     0x8007001E
				$hr = .Acquire();
				While ($hr == 0x8007001E)
					$hr = .Acquire()
				WEnd
			EndIf
		EndWith
	Next
	;
	Local $x = DllStructGetData($stDI_STATE[$j3], 1)
	Local $z = DllStructGetData($stDI_STATE[$j4], 3)
	Local $rx = DllStructGetData($stDI_STATE[$j4], 4)
	Local $lshift = State($DIK_LSHIFT) Or State($DIK_RSHIFT)
	Local $rshift = State($DIK_LSHIFT) Or State($DIK_RSHIFT)
	Local $alt = State($DIK_LALT) Or State($DIK_RALT)
	Local $control = State($DIK_LCONTROL) Or State($DIK_RCONTROL)
	Local $but1 = State($DIK_3)

	Local $mouse = Doubleclicked("mouse.leftbutton")
	$mouse = Keepdown("joystick1.button1", "2s")
	; sample of test var -> $but3 must be global   and test prefixed with 'var.but3'
	$but3 = Helddown("joystick1.pov1up", "3s")
	If Pressed("var.but3") Then Beep(1000, 500)
	If Not $lshift And Not $control And Released($DIK_COLON) Then Beep(500, 500)
	If Pressed($DIK_ESCAPE) And $lshift Then
		write("count = " & $frame & "/" & _Timer_KillAllTimers($WinHandle))
		_Quit()
		Exit
	EndIf
	If Pressed($DIK_4) Then Beep(1000, 400)

	GUICtrlSetData($i3, $rx)
	GUICtrlSetData($i2, $x)


	_SetVjoyButton(2, Helddown($DIK_2, "2s"))
	_SetVjoyButton(1, State($DIK_3))
	_SetVjoyAxis(32767, $HID_USAGE_Z)
	_SetVjoyAxis(16384, $HID_USAGE_RX)

	; Transfert data to data_laststate
	For $i = 0 To $cNbDev - 1
		If Not IsObj($oDev[$i]) Then ContinueLoop
		_MoveMemory(DllStructGetPtr($stDI_LASTSTATE[$i]), DllStructGetPtr($stDI_STATE[$i]), DllStructGetSize($stDI_STATE[$i]))
	Next
	If $Array_Var[0] Then
		For $i = 1 To $Array_Var[0]
			Assign($Array_Var[$i], Eval(StringReplace($Array_Var[$i], "_LASTSTATE", "")), 4)
		Next
	EndIf
EndFunc   ;==>_GetData
;WEnd

#region Keyboard
Func InitKeyboard()
	Local $c_dikeyboard = InitSpecialDIConstant("keyboard")
	$oIDirectInput8.CreateDevice(DllStructGetPtr(Eval("tGUID_SysKeyboard")), $pIDirectInputDevice8, 0)
	; interface of device objet
	$oDev[$k1] = ObjCreateInterface($pIDirectInputDevice8, $sIID_IDirectInputDevice8, $tagIDirectInputDevice8)
	With $oDev[$k1]
		$hr = .SetDataFormat($c_dikeyboard)
		If _Failed($hr) Then _TraitError($hr, "$oKeyboard.SetDataFormat")
		$hr = .SetCooperativeLevel($WinHandle, BitOR($DISCL_NONEXCLUSIVE, $DISCL_BACKGROUND))
		If _Failed($hr) Then _TraitError($hr, "$oKeyboard.SetCooperativeLevel")
		$hr = .Acquire()
		If _Failed($hr) Then _TraitError($hr, "$oKeyboard.Acquire")
	EndWith
	$stDI_STATE[$k1] = DllStructCreate($tagDIKEYBOARDSTATE)
	$stDI_LASTSTATE[$k1] = DllStructCreate($tagDIKEYBOARDSTATE)
EndFunc   ;==>InitKeyboard
#endregion Keyboard

;~ #define   DIERR_INPUTLOST     0x8007001E
;~ #define   E_ACCESSDENIED      0x80070005

_Quit()

#region Mouse
Func InitMouse()
	Local $c_dfDIMouse = InitSpecialDIConstant("mouse")
	$oIDirectInput8.CreateDevice(DllStructGetPtr(Eval("tGUID_SysMouse")), $pIDirectInputDevice8, 0)
	; interface of device objet
	$oDev[$m1] = ObjCreateInterface($pIDirectInputDevice8, $sIID_IDirectInputDevice8, $tagIDirectInputDevice8)
	With $oDev[$m1]
		$hr = .SetDataFormat($c_dfDIMouse)
		If _Failed($hr) Then _TraitError($hr, "$oMouse.SetDataFormat")
		$hr = .SetCooperativeLevel($WinHandle, BitOR($DISCL_NONEXCLUSIVE, $DISCL_BACKGROUND))
		If _Failed($hr) Then _TraitError($hr, "$oMouse.SetCooperativeLevel")
		$hr = .Acquire()
		If _Failed($hr) Then _TraitError($hr, "$oMouse.Acquire")
	EndWith
	$stDI_STATE[$m1] = DllStructCreate($tagDIMOUSESTATE)
	$stDI_LASTSTATE[$m1] = DllStructCreate($tagDIMOUSESTATE)
EndFunc   ;==>InitMouse
#endregion Mouse

;~ #define   DIERR_INPUTLOST     0x8007001E
;~ #define   E_ACCESSDENIED      0x80070005

#region Joystick
Func InitJoystick()
	Local $c_dfDIJoystick = InitSpecialDIConstant("joystick1")
	$hr = $oIDirectInput8.EnumDevices($DI8DEVCLASS_GAMECTRL, DllCallbackGetPtr($hCallback), 0, $DIEDFL_ATTACHEDONLY)
	If _Failed($hr) Then _TraitError($hr, "$oIDirectInput8.EnumDevices")

	For $i = $j1 To $cNbDev - 1
		If Not IsObj($oDev[$i]) Then ContinueLoop
		With $oDev[$i]
			$hr = .SetCooperativeLevel($WinHandle, BitOR($DISCL_NONEXCLUSIVE, $DISCL_BACKGROUND))
			If _Failed($hr) Then _TraitError($hr, "$oIDirectInputDevice.SetCooperativeLevel")
			$hr = .SetDataFormat($c_dfDIJoystick)
			If _Failed($hr) Then _TraitError($hr, "$oIDirectInputDevice8.SetDataFormat")
			$hr = .Acquire()
			If _Failed($hr) Then _TraitError($hr, "$oIDirectInputDevice8.Acquire")
		EndWith
	Next
EndFunc   ;==>InitJoystick
#endregion Joystick

;~ #define   DIERR_INPUTLOST     0x8007001E
;~ #define   E_ACCESSDENIED      0x80070005
#region Specials Constants
Func InitSpecialDIConstant(Const $dev)
	If StringInStr($dev, "keyboard") Then Return _InitConstKeyboard()
	If StringInStr($dev, "mouse") Then Return _InitConstMouse()
	If StringInStr($dev, "joystick1") Then Return _InitConstJoystick1()
	If StringInStr($dev, "joystick2") Then Return _InitConstJoystick2()
	Return False
EndFunc   ;==>InitSpecialDIConstant

;RVA c_dijoystick2 	0x2d6c
;RVA c_dijoystick 	0x2d54
;RVA c_dikeyboard 	0x2d3c
;RVA c_dimouse		0x2d24
Func _InitConstKeyboard()
	Local $c_dikeyboard
	__DEFINE_GUID("GUID_SysKeyboard", 0x6F1D2B61, 0xD5A0, 0x11CF, 0xBF, 0xC7, 0x44, 0x45, 0x53, 0x54, 0x00, 0x00);
	$c_dikeyboard = _WinAPI_GetModuleHandle("dinput8.dll") + 0x2d3c
	Return $c_dikeyboard
EndFunc   ;==>_InitConstKeyboard
Func _InitConstMouse()
	Local $c_dfDIMouse
	__DEFINE_GUID("GUID_SysMouse", 0x6F1D2B60, 0xD5A0, 0x11CF, 0xBF, 0xC7, 0x44, 0x45, 0x53, 0x54, 0x00, 0x00);
	$c_dfDIMouse = _WinAPI_GetModuleHandle("dinput8.dll") + 0x2d24
	Return $c_dfDIMouse
EndFunc   ;==>_InitConstMouse
Func _InitConstJoystick1()
	Local $c_dfDIJoystick
	$c_dfDIJoystick = _WinAPI_GetModuleHandle("dinput8.dll") + 0x2d54
	Return $c_dfDIJoystick
EndFunc   ;==>_InitConstJoystick1
Func _InitConstJoystick2()
	Local $c_dfDIJoystick2
	$c_dfDIJoystick2 = _WinAPI_GetModuleHandle("dinput8.dll") + 0x2d6c
	Return $c_dfDIJoystick2
EndFunc   ;==>_InitConstJoystick2
#endregion Specials Constants

; Callback _EnumAllProc definition
Func _EnumAllProc($pDIinstance, $pContext)
	Local $i, $data
	;	Local $ind = DllStructCreate("dword", $pContext)
	If $pDIinstance Then
		Local $tDIDEVICEINSTANCE = DllStructCreate("dword dwSize;" & _
				"byte guidInstance[16];" & _
				"byte guidProduct[16];" & _
				"dword dwDevType;" & _
				"wchar tszInstanceName[260];" & _
				"wchar tszProductName[260];" & _
				"byte guidFFDriver[16];" & _
				"word wUsagePage;" & _
				"word wUsage;", _
				$pDIinstance)

;~ 		ConsoleWrite("guidInstance = " & _WinAPI_StringFromGUID(DllStructGetPtr($tDIDEVICEINSTANCE, "guidInstance")) & @CRLF)
;~ 		ConsoleWrite("guidProduct = " & _WinAPI_StringFromGUID(DllStructGetPtr($tDIDEVICEINSTANCE, "guidProduct")) & @CRLF)
;~ 		ConsoleWrite("guidProduct = " & DllStructGetData($tDIDEVICEINSTANCE, "dwDevType") & @CRLF)
;~ 		ConsoleWrite("tszInstanceName = " & DllStructGetData($tDIDEVICEINSTANCE, "tszInstanceName") & @CRLF)
;~ 		ConsoleWrite("tszProductName = " & DllStructGetData($tDIDEVICEINSTANCE, "tszProductName") & @CRLF)
;~ 		ConsoleWrite("guidFFDriver = " & _WinAPI_StringFromGUID(DllStructGetPtr($tDIDEVICEINSTANCE, "guidFFDriver")) & @CRLF)
;~ 		ConsoleWrite("wUsagePage = " & DllStructGetData($tDIDEVICEINSTANCE, "wUsagePage") & @CRLF)
;~ 		ConsoleWrite("wUsage = " & DllStructGetData($tDIDEVICEINSTANCE, "wUsage") & @CRLF)
;				<--- adapt following what you want ----->
		$data = DllStructGetData($tDIDEVICEINSTANCE, "tszInstanceName")
		Select
			Case StringInStr($data, "Volant Microsoft SideWinder Force Feedback 2") > 0
				$i = $j1
			Case StringInStr($data, "Saitek") > 0 ;"Saitek"  "vJoy Device"
				$i = $j3
			Case StringInStr($data, "SideWinder Precision Racing Wheel Microsoft") > 0
				$i = $j2
			Case StringInStr($data, "vjoy") > 0
				$i = $j4
			Case Else
				Return $DIENUM_CONTINUE
		EndSelect
		ConsoleWrite("*** DevId " & $i & " joy" & $i - $j1 + 1 & " ** " & $data & @CRLF)

		;pointer of objet device
		$oIDirectInput8.CreateDevice(DllStructGetPtr($tDIDEVICEINSTANCE, "guidInstance"), $pIDirectInputDevice8, 0)
		; interface of device objet
		$oDev[$i] = ObjCreateInterface($pIDirectInputDevice8, $sIID_IDirectInputDevice8, $tagIDirectInputDevice8)

		Local $st1 = DllStructCreate("dword dwSize;")
		DllStructSetData($st1, "dwSize", $i)
		With $oDev[$i]
			$hr = .EnumObjects(DllCallbackGetPtr($hEnumObjectsCallback), DllStructGetPtr($st1), $DIDFT_RELAXIS)
			If _Failed($hr) Then _TraitError($hr, "$oIDirectInput8.EnumObjects")
		EndWith
		$stDI_STATE[$i] = DllStructCreate($tagDIJOYSTATE)
		$stDI_LASTSTATE[$i] = DllStructCreate($tagDIJOYSTATE)
	EndIf
	ConsoleWrite(@CRLF)
	$st1 = 0
	Return $DIENUM_CONTINUE
EndFunc   ;==>_EnumAllProc
;~ E_ACCESSDENIED	0x80070005	Access denied.
;~ E_FAIL	0x80004005	Unspecified error.
;~ E_INVALIDARG	0x80070057	Invalid parameter value.
;~ E_OUTOFMEMORY	0x8007000E	Out of memory.
;~ E_POINTER	0x80004003	NULL was passed incorrectly for a pointer value.
;~ E_UNEXPECTED	0x8000FFFF	Unexpected condition.
;~ S_OK	0x0	Success.
;~ S_FALSE	0x1	Success.

Func _EnumObjectsProc($pddoi, $pContext)
	Local $dwType
	Local $st1 = DllStructCreate("dword dwSize;", $pContext)
	Local $i = DllStructGetData($st1, "dwSize")
	Local $stDIDEVICEOBJECTINSTANCE = DllStructCreate( _
			"dword dwSize;" & _
			"byte guidType[16];" & _
			"dword dwOfs;" & _
			"dword dwType;" & _
			"dword dwFlags;" & _
			"wchar tszName[260];" & _
			"dword dwFFMaxForce;" & _
			"dword dwFFForceResolution;" & _
			"word wCollectionNumber;" & _
			"word wDesignatorIndex;" & _
			"word wUsagePage;" & _
			"word wUsage;" & _
			"dword dwDimension;" & _
			"word wExponent;" & _
			"word wReportId;", $pddoi)

	$dwType = DllStructGetData($stDIDEVICEOBJECTINSTANCE, "dwType")

	ConsoleWrite("ObjectName = " & DllStructGetData($stDIDEVICEOBJECTINSTANCE, "tszName"))
	ConsoleWrite(" dwType = " & DllStructGetData($stDIDEVICEOBJECTINSTANCE, "dwType"))

	GetProperty($oDev[$i], $dwType, $DIPROP_RANGE, "RANGE")
	GetProperty($oDev[$i], $dwType, $DIPROP_LOGICALRANGE, "LOGICALRANGE")
	GetProperty($oDev[$i], $dwType, $DIPROP_PHYSICALRANGE, "PHYSICALRANGE")
;	SetProperty($oDev[$i], $dwType, $DIPROP_RANGE, -100, 100)
;	GetProperty($oDev[$i], $dwType, $DIPROP_RANGE, "RANGEN")

	ConsoleWrite(@CRLF)
	$st1 = 0
	$stDIDEVICEOBJECTINSTANCE = 0
	Return $DIENUM_CONTINUE
EndFunc   ;==>_EnumObjectsProc

Func GetCapabilities()
;~ 		Global $pDIDevCaps
;~ 		Local $tagDIDEVCAPS = _
;~ 				"dword dwSize;" & _
;~ 				"dword dwFlags;" & _
;~ 				"dword dwDevType;" & _
;~ 				"dword dwAxes;" & _
;~ 				"dword dwButtons;" & _
;~ 				"dword dwPOVs;" & _
;~ 				"dword dwFFSamplePeriod;" & _
;~ 				"dword dwFFMinTimeResolution;" & _
;~ 				"dword dwFirmwareRevision;" & _
;~ 				"dword dwHardwareRevision;" & _
;~ 				"dword dwFFDriverVersion;"
;~ 		Local $stDIDEVCAPS = DllStructCreate($tagDIDEVCAPS)
;~ 		DllStructSetData($stDIDEVCAPS, "dwSize", DllStructGetSize($stDIDEVCAPS))
;~ 		$oJoy[$i].GetCapabilities(DllStructGetPtr($stDIDEVCAPS))
;~ 		ConsoleWrite("dwFlags=" & DllStructGetData($stDIDEVCAPS, "dwFlags") & @CRLF)
;~ 		ConsoleWrite("dwDevType=" & DllStructGetData($stDIDEVCAPS, "dwDevType") & @CRLF)
;~ 		ConsoleWrite("dwAxes=" & DllStructGetData($stDIDEVCAPS, "dwAxes") & @CRLF)
;~ 		ConsoleWrite("dwButtons=" & DllStructGetData($stDIDEVCAPS, "dwButtons") & @CRLF)
;~ 		ConsoleWrite("dwPOVs=" & DllStructGetData($stDIDEVCAPS, "dwPOVs") & @CRLF)
;~ 		ConsoleWrite("dwFFSamplePeriod="  & DllStructGetData($stDIDEVCAPS, "dwFFSamplePeriod") & @CRLF)
;~ 		ConsoleWrite("dwFFMinTimeResolution="  & DllStructGetData($stDIDEVCAPS, "dwFFMinTimeResolution") & @CRLF)
;~ 		ConsoleWrite("dwFirmwareRevision="  & DllStructGetData($stDIDEVCAPS, "dwFirmwareRevision") & @CRLF)
;~ 		ConsoleWrite("dwHardwareRevision="  & DllStructGetData($stDIDEVCAPS, "dwHardwareRevision") & @CRLF)
;~ 		ConsoleWrite("dwFFDriverVersion="  & DllStructGetData($stDIDEVCAPS, "dwFFDriverVersion") & @CRLF)
EndFunc   ;==>GetCapabilities

Func GetProperty(ByRef $oDev, ByRef $type, Const $DIPROP, Const $c)
	Local $tagDIPROPRANGE = _
			"dword dwSize;" & _
			"dword dwHeaderSize;" & _
			"dword dwObj;" & _
			"dword dwHow;" & _
			"long lMin;" & _
			"long lMax;"

	$stDIPROPRANGE = DllStructCreate($tagDIPROPRANGE)
	DllStructSetData($stDIPROPRANGE, "dwSize", DllStructGetSize($stDIPROPRANGE))
	DllStructSetData($stDIPROPRANGE, "dwHeaderSize", 16);$tagDIPROPHEADER
	DllStructSetData($stDIPROPRANGE, "dwObj", $type)
	DllStructSetData($stDIPROPRANGE, "dwHow", $DIPH_BYID)
	$hr = $oDev.GetProperty($DIPROP, DllStructGetPtr($stDIPROPRANGE))
	If _Failed($hr) Then _TraitError($hr, "$oIDirectInput8.GetProperty")
	ConsoleWrite(" **  Min/Max " & $c & " = " & DllStructGetData($stDIPROPRANGE, "lMin") & "/" & DllStructGetData($stDIPROPRANGE, "lMax"))

;~  DllStructSetData($stDIPROPRANGE, "dwSize", DllStructGetSize($stDIPROPRANGE)-4)
;~ 	$hr = $oDev.GetProperty($DIPROP_DEADZONE, DllStructGetPtr($stDIPROPRANGE))
;~ 	ConsoleWrite(" Deadzone " & DllStructGetData($stDIPROPRANGE, "lMin"))

	$stDIPROPRANGE = 0
EndFunc   ;==>GetProperty

Func SetProperty(ByRef $oDev, ByRef $type, Const $DIPROP, $min = 0, $max = 65535)
	Local $tagDIPROPRANGE = _
			"dword dwSize;" & _
			"dword dwHeaderSize;" & _
			"dword dwObj;" & _
			"dword dwHow;" & _
			"long;" & _
			"long;"

	$stDIPROPRANGE = DllStructCreate($tagDIPROPRANGE)
	DllStructSetData($stDIPROPRANGE, "dwSize", DllStructGetSize($stDIPROPRANGE))
	DllStructSetData($stDIPROPRANGE, "dwHeaderSize", 16);$tagDIPROPHEADER
	DllStructSetData($stDIPROPRANGE, "dwObj", $type)
	DllStructSetData($stDIPROPRANGE, "dwHow", $DIPH_BYID)
	DllStructSetData($stDIPROPRANGE, 5, $min)
	DllStructSetData($stDIPROPRANGE, 6, $max)
	$hr = $oDev.SetProperty($DIPROP_RANGE, DllStructGetPtr($stDIPROPRANGE))
	If _Failed($hr) Then _TraitError($hr, "$oIDirectInput8.SetProperty")
	$stDIPROPRANGE = 0
EndFunc   ;==>SetProperty

Func State($x)
	Local $d, $t, $idjoy

	$d = StringRegExp($x, $pat_joybut, 1)
	If Not @error Then
		$idjoy = Eval("j" & $d[0])
		If Not IsObj($oDev[$idjoy]) Then Return False
		Return BitAND(DllStructGetData($stDI_STATE[$idjoy], 9, $d[1]), 0x80) > 0
	EndIf

	$d = StringRegExp($x, $pat_joypov, 1)
	If Not @error Then
		$idjoy = Eval("j" & $d[0])
		If Not IsObj($oDev[$idjoy]) Then Return False
		Switch UBound($d)
			Case 3 ;joystick1.pov1.(up, down, left or right) return true or false
				Return DllStructGetData($stDI_STATE[$idjoy], 8, $d[1]) = Eval($d[2])
			Case 2 ;joystick1.pov1 return -1, 0, 1, 2 or 3
				$t = DllStructGetData($stDI_STATE[$idjoy], 8, $d[1])
				If $t < 0 Then Return $t
				Return Int($t / 9000)
		EndSwitch
	EndIf

	$d = StringRegExp($x, $pat_mouse, 1)
	If Not @error Then
		Return BitAND(DllStructGetData($stDI_STATE[$m1], 4, Eval($d[0]) + 1), 0x80) > 0
	EndIf

	$d = StringRegExp($x, $pat_keyboard, 1)
	If Not @error Then
		Return BitAND(DllStructGetData($stDI_STATE[$k1], 1, $d[0] + 1), 0x80) > 0
	EndIf

	$d = StringRegExp($x, $pat_var, 1)
	If Not @error Then
		;		Return BitAND(Eval($d[0]), 0x80) > 0
		Return BitAND(Eval($d[0]), 0x01)
	EndIf
EndFunc   ;==>State

Func Pressed($x)
	Local $d, $idjoy
	$d = StringRegExp($x, $pat_joybut, 1)
	If Not @error Then
		$idjoy = Eval("j" & $d[0])
		If Not IsObj($oDev[$idjoy]) Then Return False
		Return BitAND(DllStructGetData($stDI_STATE[$idjoy], 9, $d[1]), 0x80, BitNOT(DllStructGetData($stDI_LASTSTATE[$idjoy], 9, $d[1]))) > 0
	EndIf

	$d = StringRegExp($x, $pat_joypov, 1)
	If Not @error Then
		$idjoy = Eval("j" & $d[0])
		If Not IsObj($oDev[$idjoy]) Then Return False
		Return BitAND(DllStructGetData($stDI_STATE[$idjoy], 8, $d[1]) = Eval($d[2]), DllStructGetData($stDI_LASTSTATE[$idjoy], 8, $d[1]) = -1)
	EndIf

	$d = StringRegExp($x, $pat_mouse, 1)
	If Not @error Then
		Return BitAND(DllStructGetData($stDI_STATE[$m1], 4, Eval($d[0]) + 1), 0x80, BitNOT(DllStructGetData($stDI_LASTSTATE[$m1], 4, Eval($d[0]) + 1))) > 0
	EndIf

	$d = StringRegExp($x, $pat_keyboard, 1)
	If Not @error Then
		Return BitAND(DllStructGetData($stDI_STATE[$k1], 1, $d[0] + 1), 0x80, BitNOT(DllStructGetData($stDI_LASTSTATE[$k1], 1, $d[0] + 1))) > 0
	EndIf

	$d = StringRegExp($x, $pat_var, 1)
	If Not @error Then
		If Not IsDeclared($d[0] & "_LASTSTATE") Then _VARCreate($d[0], $PRESSED)
		Return BitAND(Eval($d[0]), 0x01, BitNOT(Eval($d[0] & "_LASTSTATE")))
	EndIf
EndFunc   ;==>Pressed

Func Released($x)
	Local $d, $idjoy

	$d = StringRegExp($x, $pat_joybut, 1)
	If Not @error Then
		$idjoy = Eval("j" & $d[0])
		If Not IsObj($oDev[$idjoy]) Then Return False
		Return BitAND(DllStructGetData($stDI_LASTSTATE[$idjoy], 9, $d[1]), 0x80, BitNOT(DllStructGetData($stDI_STATE[$idjoy], 9, $d[1]))) > 0
	EndIf

	$d = StringRegExp($x, $pat_joypov, 1)
	If Not @error Then
		$idjoy = Eval("j" & $d[0])
		If Not IsObj($oDev[$idjoy]) Then Return False
		Return BitAND(DllStructGetData($stDI_LASTSTATE[$idjoy], 8, $d[1]) = Eval($d[2]), DllStructGetData($stDI_STATE[$idjoy], 8, $d[1]) = -1)
	EndIf

	$d = StringRegExp($x, $pat_mouse, 1)
	If Not @error Then
		Return BitAND(DllStructGetData($stDI_LASTSTATE[$m1], 4, Eval($d[0]) + 1), 0x80, BitNOT(DllStructGetData($stDI_STATE[$m1], 4, Eval($d[0]) + 1))) > 0
	EndIf

	$d = StringRegExp($x, $pat_keyboard, 1)
	If Not @error Then
		Return BitAND(DllStructGetData($stDI_LASTSTATE[$k1], 1, $d[0] + 1), 0x80, BitNOT(DllStructGetData($stDI_STATE[$k1], 1, $d[0] + 1))) > 0
	EndIf

	$d = StringRegExp($x, $pat_var, 1)
	If Not @error Then
		If Not IsDeclared($d[0] & "_LASTSTATE") Then _VARCreate($d[0], $RELEASED)
		Return BitAND(Eval($d[0] & "_LASTSTATE"), 0x01, BitNOT(Eval($d[0])))
	EndIf
EndFunc   ;==>Released

Func Helddown($x, $sLapse)
	Local $d, $v, $t, $idjoy
	$sLapse = StringReplace($sLapse, "ms", "")
	$sLapse = StringReplace($sLapse, "s", "*1000")
	$sLapse = Execute($sLapse)

	$d = StringRegExp($x, $pat_joybut, 1)
	If Not @error Then
		$idjoy = Eval("j" & $d[0])
		If Not IsObj($oDev[$idjoy]) Then Return False
		$v = "joy" & $idjoy - $j1 + 1 & "but" & $d[1] & "_H"
		$t = $v & $sLapse
		If Not IsDeclared($t) Then _VARCreate($v, $HELDDOWN, $sLapse)
		If State($x) Then Return _TIMER_TEST($v, $sLapse)
		Assign($t, 0, 4)
		Return False
	EndIf

	$d = StringRegExp($x, $pat_joypov, 1)
	If Not @error Then
		$idjoy = Eval("j" & $d[0])
		If Not IsObj($oDev[$idjoy]) Then Return False
		$v = "joy" & $idjoy - $j1 + 1 & "pov" & $d[1] & $d[2] & "_H"
		$t = $v & $sLapse
		If Not IsDeclared($t) Then _VARCreate($v, $HELDDOWN, $sLapse)
		If State($x) Then Return _TIMER_TEST($v, $sLapse)
		Assign($t, 0, 4)
		Return False
	EndIf

	$d = StringRegExp($x, $pat_mouse, 1)
	If Not @error Then
		$v = "mouse" & $d[0] & "_H"
		$t = $v & $sLapse
		If Not IsDeclared($t) Then _VARCreate($v, $HELDDOWN, $sLapse)
		If State($x) Then Return _TIMER_TEST($v, $sLapse)
		Assign($t, 0, 4)
		Return False
	EndIf

	$d = StringRegExp($x, $pat_keyboard, 1)
	If Not @error Then
		$v = $d[0] & "_H"
		$t = $v & $sLapse
		If Not IsDeclared($t) Then _VARCreate($v, $HELDDOWN, $sLapse)
		If State($x) Then Return _TIMER_TEST($v, $sLapse)
		Assign($t, 0, 4)
		Return False
	EndIf

	$d = StringRegExp($x, $pat_var, 1)
	If Not @error Then
		$v = $d[0] & "_H"
		$t = $v & $sLapse
		If Not IsDeclared($t) Then _VARCreate($v, $HELDDOWN, $sLapse)
		If State($x) Then Return _TIMER_TEST($v, $sLapse)
		Assign($t, 0, 4)
		Return False
	EndIf
EndFunc   ;==>Helddown

Func Keepdown($x, $sLapse)
	Local $d, $v, $t, $idjoy
	$sLapse = StringReplace($sLapse, "ms", "")
	$sLapse = StringReplace($sLapse, "s", "*1000")
	$sLapse = Execute($sLapse)

	$d = StringRegExp($x, $pat_joybut, 1)
	If Not @error Then
		$idjoy = Eval("j" & $d[0])
		If Not IsObj($oDev[$idjoy]) Then Return False
		$v = "joy" & $idjoy - $j1 + 1 & "but" & $d[1] & "_K"
		$t = $v & $sLapse
		If Not IsDeclared($t) Then _VARCreate($v, $HELDDOWN, $sLapse)
		If Eval($t) And Not state($x) Then
			If Not _TIMER_TEST($v, $sLapse) Then Return True
			Assign($t, 0, 4)
			Return False
		EndIf
		If Released($x) Then Return Not _TIMER_TEST($v, $sLapse)
		Return False
	EndIf

	$d = StringRegExp($x, $pat_joypov, 1)
	If Not @error Then
		$idjoy = Eval("j" & $d[0])
		If Not IsObj($oDev[$idjoy]) Then Return False
		$v = "joy" & $idjoy - $j1 + 1 & "pov" & $d[1] & $d[2] & "_K"
		$t = $v & $sLapse
		If Not IsDeclared($t) Then _VARCreate($v, $HELDDOWN, $sLapse)
		If Eval($t) Then
			If TimerDiff(Eval($t)) <= $sLapse Then Return True
			Assign($t, 0, 4)
			Return False
		EndIf
		If Released($x) Then Return Not _TIMER_TEST($v, $sLapse)
		Return False
	EndIf

	$d = StringRegExp($x, $pat_mouse, 1)
	If Not @error Then
		$v = "mouse" & $d[0] & "_K"
		$t = $v & $sLapse
		If Not IsDeclared($t) Then _VARCreate($v, $HELDDOWN, $sLapse)
		If Eval($t) Then
			If TimerDiff(Eval($t)) <= $sLapse Then Return True
			Assign($t, 0, 4)
			Return False
		EndIf
		If Released($x) Then Return Not _TIMER_TEST($v, $sLapse)
		Return False
	EndIf

	$d = StringRegExp($x, $pat_keyboard, 1)
	If Not @error Then
		$v = $d[0] & "_K"
		$t = $v & $sLapse
		If Not IsDeclared($t) Then _VARCreate($v, $HELDDOWN, $sLapse)
		If Eval($t) Then
			If TimerDiff(Eval($t)) <= $sLapse Then Return True
			Assign($t, 0, 4)
			Return False
		EndIf
		If Released($x) Then Return Not _TIMER_TEST($v, $sLapse)
		Return False
	EndIf

	$d = StringRegExp($x, $pat_var, 1)
	If Not @error Then
		$v = $d[0] & "_K"
		$t = $v & $sLapse
		If Not IsDeclared($t) Then _VARCreate($v, $HELDDOWN, $sLapse)
		If Eval($t) Then
			If TimerDiff(Eval($t)) <= $sLapse Then Return True
			Assign($t, 0, 4)
			Return False
		EndIf
		If Released($x) Then Return Not _TIMER_TEST($v, $sLapse)
		Return False
	EndIf
EndFunc   ;==>Keepdown

Func Doubleclicked($x, $sLapse = $DEFLAPSE)
	Local $d, $v, $t, $idjoy

	$d = StringRegExp($x, $pat_joybut, 1)
	If Not @error Then
		$idjoy = Eval("j" & $d[0])
		$v = "joy" & $idjoy - $j1 + 1 & "but" & $d[1] & "_D"
		$t = $v & $sLapse
		If Not IsDeclared($t) Then _VARCreate($v, $DOUBLECLICKED, $sLapse)
		If Eval($t) And TimerDiff(Eval($t)) > $sLapse Then
			Assign($t, 0, 4)
			Return False
		EndIf
		If Pressed($x) Then
			If Eval($t) Then Return True
			Return _TIMER_TEST($v, $sLapse)
		Else
			Return False
		EndIf
	EndIf

	$d = StringRegExp($x, $pat_joypov, 1)
	If Not @error Then
		$idjoy = Eval("j" & $d[0])
		$v = "joy" & $idjoy - $j1 + 1 & "pov" & $d[1] & $d[2] & "_D"
		$t = $v & $sLapse
		If Not IsDeclared($t) Then _VARCreate($v, $DOUBLECLICKED, $sLapse)
		If Eval($t) And TimerDiff(Eval($t)) > $sLapse Then
			Assign($t, 0, 4)
			Return False
		EndIf
		If Pressed($x) Then
			If Eval($t) Then Return True
			Return _TIMER_TEST($v, $DEFLAPSE)
		Else
			Return False
		EndIf
	EndIf

	$d = StringRegExp($x, $pat_mouse, 1)
	If Not @error Then
		$v = "mouse" & $d[0] & "_D"
		$t = $v & $sLapse
		If Not IsDeclared($t) Then _VARCreate($v, $DOUBLECLICKED, $sLapse)
		If Eval($t) And TimerDiff(Eval($t)) > $sLapse Then
			Assign($t, 0, 4)
			Return False
		EndIf
		If Pressed($x) Then
			If Eval($t) Then Return True
			Return _TIMER_TEST($v, $sLapse)
		Else
			Return False
		EndIf
	EndIf

	$d = StringRegExp($x, $pat_keyboard, 1)
	If Not @error Then
		$v = $d[0] & "_D"
		$t = $v & $sLapse
		If Not IsDeclared($t) Then _VARCreate($v, $DOUBLECLICKED, $sLapse)
		If Eval($t) And TimerDiff(Eval($t)) > $sLapse Then
			Assign($t, 0, 4)
			Return False
		EndIf
		If Pressed($x) Then
			If Eval($t) Then Return True
			Return _TIMER_TEST($v, $sLapse)
		Else
			Return False
		EndIf
	EndIf

	$d = StringRegExp($x, $pat_var, 1)
	If Not @error Then
		$v = $d[0] & "_D"
		$t = $v & $sLapse
		If Not IsDeclared($t) Then _VARCreate($v, $DOUBLECLICKED, $sLapse)
		If Eval($t) And TimerDiff(Eval($t)) > $sLapse Then
			Assign($t, 0, 4)
			Return False
		EndIf
		If Pressed($x) Then
			If Eval($v) Then Return True
			Return _TIMER_TEST($v, $sLapse)
		Else
			Return False
		EndIf
	EndIf
	Return False
EndFunc   ;==>Doubleclicked

;~ STATE("joy.1.but.2")
;~ Func STATE($sA);"joy.1.but.2", "joy.1.pov.1", "joy.1.pov.1.up", "mouse.1.DIMOUSE_MIDDLEBUTTON", "key.1.DIK_ESCAPE", "var.throttle"
;~ 	Local $device, $arg1, $arg2, $arg3, $arg4
;~ 	Decode($sA, $device, $arg1, $arg2, $arg3, $arg4)
;~ EndFunc   ;==>STATE

Func _VARCreate($var, $c_STATE = $PRESSED, $sLapse = $DEFLAPSE)
	Switch $c_STATE
		Case $PRESSED To $RELEASED
			Assign($var & "_LASTSTATE", False, 2)
			_ArrayAdd($Array_Var, $var & "_LASTSTATE")
			$Array_Var[0] += 1
			write("*******cre " & $var & "_LASTSTATE  ** " & $c_STATE & "*** " & $Array_Var[0])
		Case $HELDDOWN To $DOUBLECLICKED
			Assign($var & $sLapse, False, 2)
			write("*******cre " & $var & $sLapse)
	EndSwitch
EndFunc   ;==>_VARCreate

Func _TIMER_TEST(ByRef $var, $sLapse = $DEFLAPSE, $c_STATE = $HELDDOWN)
	If Not Eval($var & $sLapse) Then
		Assign($var & $sLapse, TimerInit(), 4)
		write("init " & $var & $sLapse & " = " & Eval($var & $sLapse))
		Return False
	EndIf
	If TimerDiff(Eval($var & $sLapse)) > $sLapse Then Return True
	Return False
EndFunc   ;==>_TIMER_TEST

Func write($t)
	ConsoleWrite($t & @CRLF)
EndFunc   ;==>write

; On Exit Function
Func _Quit()
	Local $i
	$voice = 0
	_Vjoy_Stop(1)
	_Release_Dinput_Device($oDev[$k1], "Keyboard")
	_Release_Dinput_Device($oDev[$m1], "Mouse")
	For $i = $j1 To $cNbDev - 1
		If IsObj($oDev[$i]) Then _Release_Dinput_Device($oDev[$i], "Joystick")
	Next
	$oIDirectInput8.Release()
	$oIDirectInput8 = 0
	Exit
EndFunc   ;==>_Quit

Func _Release_Dinput_Device(ByRef $oDevice, $str)
	ConsoleWrite("Release " & $str & @CRLF)
	With $oDevice
		$hr = .Unacquire()
		If _Failed($hr) Then _TraitError($hr, "$oDevice.Unacquire")
		$hr = .Release()
		If _Failed($hr) Then _TraitError($hr, "$oDevice.Release")
	EndWith
	$oDevice = 0
EndFunc   ;==>_Release_Dinput_Device
;~ const DIDATAFORMAT c_dfDIKeyboard =
;~ -{
;~ -        /* dwSize =     */ 24,
;~ -        /* dwObjSize =  */ 16,
;~ -        /* dwFlags =    */ DIDF_RELAXIS,
;~ -        /* dwDataSize = */ 256,
;~ -        /* dwNumObjs =  */ 256,
;~ -        /* rgodf =      */ &diodfKeyData[0]
;~ -};
;~ -
;~ -const DIDATAFORMAT c_dfDIJoystick =
;~ -{
;~ -        /* dwSize =     */ 24,
;~ -        /* dwObjSize =  */ 16,
;~ -        /* dwFlags =    */ DIDF_ABSAXIS,
;~ -        /* dwDataSize = */ 80,
;~ -        /* dwNumObjs =  */ 44,
;~ -        /* rgodf =      */ &diodfJoyData[0]
;~ -};
;~ -
;~ -const DIDATAFORMAT c_dfDIJoystick2 = {
;~ -        /* dwSize =     */ 24,
;~ -        /* dwObjSize =  */ 16,
;~ -        /* dwFlags =    */ DIDF_ABSAXIS,
;~ -        /* dwDataSize = */ 272,
;~ -        /* dwNumObjs =  */ 164,
;~ -        /* rgodf =      */ &diodfJoy2Data[0]
;~ -};
;~ -
;~ -const DIDATAFORMAT c_dfDIMouse =
;~ -{
;~ -	/* dwSize =     */ 24,
;~ -	/* dwObjSize =  */ 16,
;~ -	/* dwFlags =    */ DIDF_RELAXIS,
;~ -	/* dwDataSize = */ 16,
;~ -	/* dwNumObjs =  */ 7,
;~ -	/* rgodf =      */ &diodfMouseData[0]
;~ -};

Func BufferizeData($button)
	;	DllStructSetData($stVjoy, "bDevice", 1)
	DllStructSetData($stVjoy, "lButtons", $button)
;~ 	DllStructSetData($stVjoy, "wThrottle", 0)
;~ 	DllStructSetData($stVjoy, "wRudder", 0)
;~ 	DllStructSetData($stVjoy, "wAileron", 0)
	DllStructSetData($stVjoy, "wAxisX", 16383)
	DllStructSetData($stVjoy, "wAxisY", 16383)
	DllStructSetData($stVjoy, "wAxisZ", 16383)
	DllStructSetData($stVjoy, "wAxisXRot", 16383)
	DllStructSetData($stVjoy, "wAxisYRot", 16383)
	DllStructSetData($stVjoy, "wAxisZRot", 16383)
	DllStructSetData($stVjoy, "wSlider", 16383)
	DllStructSetData($stVjoy, "wDial", 16383)
;~ 	DllStructSetData($stVjoy, "wWheel", 32767)
;~ 	DllStructSetData($stVjoy, "wAxisVX", 32767)
;~ 	DllStructSetData($stVjoy, "wAxisVY", 32767)
;~ 	DllStructSetData($stVjoy, "wAxisVZ", 32767)
;~ 	DllStructSetData($stVjoy, "wAxisVBRX", 32767)
;~ 	DllStructSetData($stVjoy, "wAxisVBRY", 32767)
;~ 	DllStructSetData($stVjoy, "wAxisVBRZ", 32767)
	DllStructSetData($stVjoy, "bHats", -1)
	;	DllStructSetData($stVjoy, "bHatsEx1", 1)
EndFunc   ;==>BufferizeData

Func SetVjoyAxis($value, $Axis, $device = 1)
	DllStructSetData($stVjoy, $Axis, $value)
EndFunc   ;==>SetVjoyAxis
Func _SetVjoyAxis($value, $Axis, $device = 1)
	DllCall($hDLLVjoy, "BOOL:cdecl", "SetAxis", "long", $value, "uint", $device, "uint", $Axis)
EndFunc   ;==>_SetVjoyAxis

Func SetVjoyPov($value, $idpov = 1, $device = 1)
	DllStructSetData("bHats", $value, $idpov)
EndFunc   ;==>SetVjoyPov
Func _SetVjoyDiscPov($value, $idpov = 1, $device = 1)
	DllCall($hDLLVjoy, "BOOL:cdecl", "SetDiscPov", "int", $value, "uint", $device, "BYTE", $idpov);-1 0 1 2 3
EndFunc   ;==>_SetVjoyDiscPov
Func _SetContPov($value, $idpov = 1, $device = 1)
	DllCall($hDLLVjoy, "BOOL:cdecl", "SetContPov", "dword", $value, "int", $device, "BYTE", $idpov)
EndFunc   ;==>_SetContPov

Func SetVjoyButton($bool, Const $iNum, $device = 1)
	;0x00000001 btn01   0x80000000 btn32
	Local $but
	$but = DllStructGetData($stVjoy, "lButtons")
	$but = BitOR($but, BitShift($bool, 1 - $iNum))
	DllStructSetData($stVjoy, "lButtons", $but)
EndFunc   ;==>SetVjoyButton
Func _SetVjoyButton($bool, $iNum, $device = 1)
	DllCall($hDLLVjoy, "BOOL:cdecl", "SetBtn", "BOOL", $bool, "uint", $device, "BYTE", $iNum); $iNum can range 1-32
EndFunc   ;==>_SetVjoyButton

;~ guidInstance = {3DD21310-4A21-11E2-8002-444553540000}
;~ *** DevId 5 joy4 ** vJoy Device
;~ ObjectName = Axe X dwType = 2/0 **  Min/Max RANGE = 0/65535 **  Min/Max LOGICALRANGE = 0/32767 **  Min/Max PHYSICALRANGE = 0/32767
;~ ObjectName = Axe Y dwType = 258/4 **  Min/Max RANGE = 0/65535 **  Min/Max LOGICALRANGE = 0/32767 **  Min/Max PHYSICALRANGE = 0/32767
;~ ObjectName = Axe Z dwType = 514/8 **  Min/Max RANGE = 0/65535 **  Min/Max LOGICALRANGE = 0/32767 **  Min/Max PHYSICALRANGE = 0/32767
;~ ObjectName = Rotation X dwType = 770/12 **  Min/Max RANGE = 0/65535 **  Min/Max LOGICALRANGE = 0/32767 **  Min/Max PHYSICALRANGE = 0/32767
;~ ObjectName = Rotation Y dwType = 1026/16 **  Min/Max RANGE = 0/65535 **  Min/Max LOGICALRANGE = 0/32767 **  Min/Max PHYSICALRANGE = 0/32767
;~ ObjectName = Rotation Z dwType = 1282/20 **  Min/Max RANGE = 0/65535 **  Min/Max LOGICALRANGE = 0/32767 **  Min/Max PHYSICALRANGE = 0/32767
;~ ObjectName = Curseur dwType = 1538/24 **  Min/Max RANGE = 0/65535 **  Min/Max LOGICALRANGE = 0/32767 **  Min/Max PHYSICALRANGE = 0/32767
;~ ObjectName = Cadran dwType = 1794/28 **  Min/Max RANGE = 0/65535 **  Min/Max LOGICALRANGE = 0/32767 **  Min/Max PHYSICALRANGE = 0/32767























